--- linux-2.6.27.6/drivers/char/mem.c	2008-11-14 01:56:21.000000000 +0800
+++ linux-2.6.27.6.yaffs/drivers/char/mem.c	2011-05-08 18:00:43.000000000 +0800
@@ -35,6 +35,8 @@
 # include <linux/efi.h>
 #endif
 
+unsigned int uca =1;
+unsigned long fb_start = 0xffffffffUL, fb_end = 0xffffffffUL;
 /*
  * Architectures vary in how they handle caching for addresses
  * outside of main memory.
@@ -61,6 +63,12 @@
 	 */
 	if (file->f_flags & O_SYNC)
 		return 1;
+#if defined(CONFIG_CPU_LOONGSON2) && defined(CONFIG_64BIT)
+       return (addr >= __pa(high_memory)) || ((addr >=0x10000000) && (addr < 0x80000000));
+#else
+         return addr >= __pa(high_memory);
+#endif
+
 	return addr >= __pa(high_memory);
 #endif
 }
@@ -354,6 +362,13 @@
 						 size,
 						 vma->vm_page_prot);
 
+	if (uca) {
+		unsigned offset = vma->vm_pgoff << PAGE_SHIFT;
+		if (offset >= fb_start && offset < fb_end){
+			vma->vm_page_prot = __pgprot((pgprot_val(vma->vm_page_prot)&~_CACHE_MASK)|_CACHE_UNCACHED_ACCELERATED);
+		}
+	}
+
 	vma->vm_ops = &mmap_mem_ops;
 
 	/* Remap-pfn-range will mark the range VM_IO and VM_RESERVED */
@@ -1000,3 +1015,59 @@
 }
 
 fs_initcall(chr_dev_init);
+
+/*setup for godson uncache acceleration*/
+
+#include <linux/pci.h>
+#ifndef pci_for_each_dev
+#define pci_for_each_dev for_each_pci_dev
+#endif
+static int __init find_vga_mem_init(void)
+{
+       struct pci_dev *dev = 0;
+       struct resource *r;
+       int idx;
+       printk("begin to find the vga mem range\n");
+       if(!uca)return 0;
+       pci_for_each_dev(dev) {
+               //if ((dev->class >> 8) == PCI_CLASS_DISPLAY_VGA){
+               if ((dev->class >> 8) == 0x0380){
+                       for (idx=0; idx < PCI_NUM_RESOURCES; idx++) {
+                               r = &dev->resource[idx];
+                               if (!r->start && r->end) {
+                                       continue;
+                               }
+                               if (r->flags & IORESOURCE_IO)
+                                       continue;
+                               if (r->flags & IORESOURCE_MEM){
+                                       fb_start = r->start;
+                                       fb_end  = r->end;
+                                       printk("find the frame buffer:start=%lx,end=%lx\n", fb_start, fb_end);
+                                       return 0;
+                               }
+                       }
+
+               }
+       }
+       printk("<0>can not find vga device\n");
+       return 0;
+}
+
+late_initcall(find_vga_mem_init);
+
+static int __init uca_setup(char *str)
+{
+       char tmp[100], *end;
+
+       uca = 1;
+       strncpy(tmp, str, 100);
+       fb_start = simple_strtoul(tmp, &end, 16);
+       if (end && *end) {
+                       end ++;
+                       fb_end = fb_start + simple_strtoul(end, NULL, 16) ;
+       }
+
+       return 0;
+}
+
+__setup("uca=", uca_setup);
